## opengtl 0.9.5

=== CMakeLists.txt ===
project(OpenGTL)

cmake_minimum_required(VERSION 2.6)

set(LIB_SUFFIX "" CACHE STRING "Define suffix of directory name (32/64)" )

enable_testing()

set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/modules )

set(OPENGTL_VERSION "0.9.5")
set(OPENGTL_LIB_VERSION ${OPENGTL_VERSION})
set(OPENGTL_LIB_SOVERSION "0.4")

set(LIB_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}/)
set(INCLUDE_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/include/)
set(BIN_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/bin/)
set(SHARE_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/share/OpenGTL/)
set(GTLIMAGEIO_EXTENSIONS_INSTALL_DIR ${SHARE_INSTALL_DIR}/GTLImageIO/Extensions)

add_definitions(-Wall -Werror )

find_package(LLVM REQUIRED)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/OpenGTL)

add_subdirectory(OpenGTL)
add_subdirectory(OpenCTL)
add_subdirectory(OpenShiva)
add_subdirectory(Extensions)

=== Extensions/CMakeLists.txt ===
find_package(PNG )

if( PNG_FOUND )
  add_subdirectory( PngDC )
endif( PNG_FOUND )

=== OpenCTL/CMakeLists.txt ===
project(OpenCTL)

include_directories( ${CMAKE_CURRENT_SOURCE_DIR} )

set(CTLC "${CMAKE_CURRENT_BINARY_DIR}/tools/compiler/ctlc")
set(CTLI "${CMAKE_CURRENT_BINARY_DIR}/tools/interpreter/ctli")

set(OPENCTL_VERSION ${OPENGTL_VERSION})
set(OPENCTL_LIB_VERSION ${OPENGTL_LIB_VERSION})
set(OPENCTL_LIB_SOVERSION ${OPENGTL_LIB_SOVERSION})

add_subdirectory(OpenCTL)
add_subdirectory(tools)

# After tool to get CTLC variable
add_subdirectory(tests)

=== OpenGTL/CMakeLists.txt ===
include_directories( ${CMAKE_CURRENT_SOURCE_DIR} )

add_subdirectory(GTLCore)
add_subdirectory(GTLTest)
add_subdirectory(GTLImageIO)
add_subdirectory(tools)

=== OpenShiva/CMakeLists.txt ===
include_directories( ${CMAKE_CURRENT_SOURCE_DIR} )

set(SHIVAC "${CMAKE_CURRENT_BINARY_DIR}/tools/compiler/shivac")
set(SHIVAI "${CMAKE_CURRENT_BINARY_DIR}/tools/interpreter/shivai")
set(SHIVATESTER "${CMAKE_CURRENT_BINARY_DIR}/tools/tester/shivatester")


set(OPENSHIVA_VERSION ${OPENGTL_VERSION})
set(OPENSHIVA_LIB_VERSION ${OPENGTL_LIB_VERSION})
set(OPENSHIVA_LIB_SOVERSION ${OPENGTL_LIB_SOVERSION})

add_subdirectory(OpenShiva)
add_subdirectory(tools)
add_subdirectory(tests)

=== Extensions/PngDC/CMakeLists.txt ===
# add_subdirectory(tests)

## GTLImageIO library ##

include_directories(${PNG_INCLUDE_DIR})

set(PNG_DC_SRCS
    PngDC.cpp )

add_library(PngDC SHARED ${PNG_DC_SRCS} )
target_link_libraries(PngDC GTLImageIO ${PNG_LIBRARIES})

# __STDC_LIMIT_MACROS is needed by LLVM's DataTypes.h
add_definitions( "-D__STDC_LIMIT_MACROS" )
add_definitions( -DCOUMPONENT_NAME=\"\\\"PngDC\\\"\" )
add_definitions( ${PNG_DEFINITIONS} )

# Install target
install(TARGETS PngDC  DESTINATION ${GTLIMAGEIO_EXTENSIONS_INSTALL_DIR} )
# install( FILES ImageDC.h DESTINATION ${INCLUDE_INSTALL_DIR}/GTLImageIO ) # NO REASON TO INSTALL HEADERS FOR NOW

=== OpenCTL/OpenCTL/CMakeLists.txt ===

include_directories( ${LLVM_INCLUDE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/ ${CMAKE_CURRENT_SOURCE_DIR}/compiler ${CMAKE_CURRENT_BINARY_DIR} )

# List of files 
set(OpenCTL_SRCS
  Debug.cpp
  Module.cpp
  ModulesManager.cpp
  Program.cpp
# Internal files
  StdLibFunctions.cpp
  compiler/Compiler.cpp
  compiler/LexerNG.cpp
  compiler/ParserNG.cpp
  ${LLVM_NATIVE_OBJECTS}
    )

# Add the OpenCTL library for build
add_library(OpenCTL SHARED ${OpenCTL_SRCS})
target_link_libraries(OpenCTL GTLCore )

# __STDC_LIMIT_MACROS is needed by LLVM's DataTypes.h
add_definitions( "-D__STDC_LIMIT_MACROS" )
add_definitions( -DCOUMPONENT_NAME="OpenCTL" )

add_definitions( -D_OPENCTL_CTL_STD_LIB_SRC_DIR_="${CMAKE_CURRENT_SOURCE_DIR}")
add_definitions( -D_OPENCTL_CTL_SHARE_DIR_="${SHARE_INSTALL_DIR}/ctl" )


# Set the ABI version of the library
set_target_properties(OpenCTL PROPERTIES VERSION ${OPENCTL_LIB_VERSION} SOVERSION ${OPENCTL_LIB_SOVERSION} )

# Install target
install(TARGETS OpenCTL  DESTINATION ${LIB_INSTALL_DIR} )
install( FILES Module.h ModulesManager.h Program.h Version.h DESTINATION ${INCLUDE_INSTALL_DIR}/OpenCTL )

# Create and install pc file
configure_file("OpenCTL.pc.cmake" "${CMAKE_CURRENT_BINARY_DIR}/OpenCTL.pc" @ONLY)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/OpenCTL.pc DESTINATION ${LIB_INSTALL_DIR}/pkgconfig)  

# Install standard library
install(FILES ctlstdlib.ctl DESTINATION ${SHARE_INSTALL_DIR}/ctl )

=== OpenCTL/tests/CMakeLists.txt ===

add_subdirectory(library)
add_subdirectory(parse)
add_subdirectory(stdlib)
add_subdirectory(arithmetic)
add_subdirectory(statements)
add_subdirectory(misc)
add_subdirectory(complextypes)

=== OpenCTL/tools/CMakeLists.txt ===
add_subdirectory(compiler)
add_subdirectory(interpreter)

=== OpenGTL/GTLCore/CMakeLists.txt ===
add_subdirectory(tests)

# Find llvm jit, interpreter and native
FIND_LLVM_LIBS( ${LLVM_CONFIG_EXECUTABLE} "native bitwriter linker bitreader jit interpreter support ipo" LLVM_LIBS LLVM_NATIVE_OBJECTS )

include_directories( ${LLVM_INCLUDE_DIR} )

## GTLCore library ##

set(GTLCore_SRCS
  AbstractImage.cpp
  BufferImage.cpp
  Array.cpp
  Image.cpp
  Buffer.cpp
  Debug.cpp
  ErrorMessage.cpp
  Function.cpp
  Optimiser.cpp
  Parameter.cpp
  PixelDescription.cpp
  Region.cpp
  RegionF.cpp
  ScopedName.cpp
  String.cpp
  Type.cpp
  TypeManager.cpp
  Value.cpp
# Internal files
  AST/AccessorExpression.cpp
  AST/BinaryExpression.cpp
  AST/ConvertExpression.cpp
  AST/CoumpoundExpression.cpp
  AST/Expression.cpp
  AST/FunctionDeclaration.cpp
  AST/Statement.cpp
  AST/Tree.cpp
  AST/UnaryExpression.cpp
  CodeGenerator_p.cpp
  CompilerBase_p.cpp
  ConvertCenter_p.cpp
  ErrorMessages_p.cpp
  ExpressionResult_p.cpp
  Function_p.cpp
  FunctionCaller_p.cpp
  FloatHalfConverter_p.cpp
  GenerationContext_p.cpp
  LexerBase_p.cpp
  ModuleData_p.cpp
  Optimiser_p.cpp
  ParserBase_p.cpp
  Token_p.cpp
  Type_p.cpp
  TypeManager_p.cpp
  VariableNG_p.cpp
  VirtualMachine_p.cpp
  Visitor_p.cpp
  ${LLVM_NATIVE_OBJECTS}
  )


# Create GTLCore library
add_library(GTLCore SHARED ${GTLCore_SRCS} ${llvm_objects})

target_link_libraries(GTLCore ${LLVM_LIBS_JIT} ${LLVM_LDFLAGS} ${LLVM_LIBS} )

# Set the ABI version of the library
set_target_properties(GTLCore PROPERTIES VERSION ${OPENGTL_LIB_VERSION} SOVERSION ${OPENGTL_LIB_SOVERSION} )

# __STDC_LIMIT_MACROS is needed by LLVM's DataTypes.h
add_definitions( "-D__STDC_LIMIT_MACROS" )
add_definitions( -DCOUMPONENT_NAME="GTLCore" )

# installation
install(TARGETS GTLCore  DESTINATION ${LIB_INSTALL_DIR} )
install( FILES Parameter.h Function.h Array.h Buffer.h ErrorMessage.h PixelDescription.h Region.h RegionF.h ScopedName.h String.h Type.h Value.h Version.h Macros.h AbstractImage.h BufferImage.h Image.h DESTINATION ${INCLUDE_INSTALL_DIR}/GTLCore )

=== OpenGTL/GTLImageIO/CMakeLists.txt ===
# add_subdirectory(tests)

include_directories( ${LLVM_INCLUDE_DIR} )

## GTLImageIO library ##

set(GTLImageIO_SRCS
    ImageDC.cpp
    ImageDCRegistry.cpp )

add_definitions( -D_GTLIMAGEIO_EXTENSIONS_INSTALL_DIR_="${GTLIMAGEIO_EXTENSIONS_INSTALL_DIR}" )

add_library(GTLImageIO SHARED ${GTLImageIO_SRCS} )
target_link_libraries(GTLImageIO GTLCore )

# __STDC_LIMIT_MACROS is needed by LLVM's DataTypes.h
add_definitions( "-D__STDC_LIMIT_MACROS" )
add_definitions( -DCOUMPONENT_NAME="GTLImageIO" )

# Set the ABI version of the library
set_target_properties(GTLImageIO PROPERTIES VERSION ${OPENGTL_LIB_VERSION} SOVERSION ${OPENGTL_LIB_SOVERSION} )

# Install target
install(TARGETS GTLImageIO  DESTINATION ${LIB_INSTALL_DIR} )
# install( FILES ImageDC.h DESTINATION ${INCLUDE_INSTALL_DIR}/GTLImageIO ) # NO REASON TO INSTALL HEADERS FOR NOW

=== OpenGTL/GTLTest/CMakeLists.txt ===
add_subdirectory(tests)

## GTLTest library ##

set(GTLTest_SRCS
  Suite.cpp
  Case.cpp
  Result.cpp )

add_library(GTLTest SHARED ${GTLTest_SRCS} )

# Set the ABI version of the library
set_target_properties(GTLTest PROPERTIES VERSION ${OPENGTL_LIB_VERSION} SOVERSION ${OPENGTL_LIB_SOVERSION} )

## opengtl 0.9.9

=== CMakeLists.txt ===
project(OpenGTL)

cmake_minimum_required(VERSION 2.6)

set(LIB_SUFFIX "" CACHE STRING "Define suffix of directory name (32/64)" )

option(OPENGTL_BUILD_TESTS "Build tests" OFF)

set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/modules )

set(OPENGTL_VERSION "0.9.9")
set(OPENGTL_LIB_VERSION ${OPENGTL_VERSION})
set(OPENGTL_LIB_SOVERSION "0.6")

set(LIB_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}/)
set(INCLUDE_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/include/)
set(BIN_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/bin/)
set(SHARE_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/share/OpenGTL/)
set(GTLIMAGEIO_EXTENSIONS_INSTALL_DIR ${SHARE_INSTALL_DIR}/GTLImageIO/Extensions)

set(OPENGTL_TESTS_DATA "" CACHE FILEPATH "Directory that contains the data of the tests.")

include (TestBigEndian)
test_big_endian(CMAKE_WORDS_BIGENDIAN)
configure_file(config-endian.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-endian.h )

find_package(LLVM REQUIRED)
if( NOT LLVM_VERSION STREQUAL "2.5" )
  message(FATAL_ERROR "LLVM 2.5 is required.")
endif(NOT LLVM_VERSION STREQUAL "2.5" )

if(OPENGTL_BUILD_TESTS)
include(CTest)
include(Dart)
endif(OPENGTL_BUILD_TESTS)

if(CMAKE_SIZEOF_VOID_P EQUAL 4)
  # 32 bits
  message(STATUS "OpenGTL detected that you use a 32 bit processor.")
  set(OPENGTL_TESTS_DATA_RESULTS_DIR results32)
  option(OPENGTL_ENABLE_SIMD "Enable SIMD (SSE/MMX/...) instructions" OFF)
else(CMAKE_SIZEOF_VOID_P EQUAL 4)
  # 32 bits
  message(STATUS "OpenGTL detected that you use a 64 bit processor.")
  set(OPENGTL_TESTS_DATA_RESULTS_DIR results64)
  option(OPENGTL_ENABLE_SIMD "Enable SIMD (SSE/MMX/...) instructions" ON)
  # TODO check that llvm was build with -fPIC
endif(CMAKE_SIZEOF_VOID_P EQUAL 4)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/OpenGTL ${CMAKE_CURRENT_BINARY_DIR}
)

add_subdirectory(OpenGTL)
add_subdirectory(OpenCTL)
add_subdirectory(OpenShiva)
add_subdirectory(Extensions)

=== OpenCTL/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,8 @@
 project(OpenCTL)
 
 include_directories( ${CMAKE_CURRENT_SOURCE_DIR} )
+
+add_definitions(-Wall -Werror )
 
 set(CTLC "${CMAKE_CURRENT_BINARY_DIR}/tools/compiler/ctlc")
 set(CTLI "${CMAKE_CURRENT_BINARY_DIR}/tools/interpreter/ctli")

=== OpenGTL/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,6 @@
 include_directories( ${CMAKE_CURRENT_SOURCE_DIR} )
+
+add_definitions(-Wall -Werror )
 
 add_subdirectory(GTLCore)
 add_subdirectory(GTLTest)

=== OpenShiva/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,6 @@
 include_directories( ${CMAKE_CURRENT_SOURCE_DIR} )
+
+add_definitions(-Wall -Werror )
 
 set(SHIVAC "${CMAKE_CURRENT_BINARY_DIR}/tools/compiler/shivac")
 set(SHIVAI "${CMAKE_CURRENT_BINARY_DIR}/tools/interpreter/shivai")

=== Extensions/PngDC/CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,6 @@
-# add_subdirectory(tests)
+include_directories(${PNG_INCLUDE_DIR})
 
-## GTLImageIO library ##
-
-include_directories(${PNG_INCLUDE_DIR})
+add_definitions(-Wall -Werror )
 
 set(PNG_DC_SRCS
     PngDC.cpp )

=== OpenCTL/OpenCTL/CMakeLists.txt ===
--- 
+++ 
@@ -7,6 +7,7 @@
   Module.cpp
   ModulesManager.cpp
   Program.cpp
+  Version.cpp
 # Internal files
   StdLibFunctions.cpp
   compiler/Compiler.cpp
@@ -21,8 +22,10 @@
 
 # __STDC_LIMIT_MACROS is needed by LLVM's DataTypes.h
 add_definitions( "-D__STDC_LIMIT_MACROS" )
+add_definitions( "-D__STDC_CONSTANT_MACROS" )
 add_definitions( -DCOUMPONENT_NAME="OpenCTL" )
 
+add_definitions( -D_OPENCTL_LIB_="${CMAKE_INSTALL_PREFIX}/lib/libOpenCTL.so.${OPENGTL_LIB_SOVERSION}")
 add_definitions( -D_OPENCTL_CTL_STD_LIB_SRC_DIR_="${CMAKE_CURRENT_SOURCE_DIR}")
 add_definitions( -D_OPENCTL_CTL_SHARE_DIR_="${SHARE_INSTALL_DIR}/ctl" )

=== OpenCTL/tools/CMakeLists.txt ===
add_subdirectory(compiler)
add_subdirectory(interpreter)
add_subdirectory(benchmark)

=== OpenGTL/GTLCore/CMakeLists.txt ===
--- 
+++ 
@@ -9,13 +9,15 @@
 
 set(GTLCore_SRCS
   AbstractImage.cpp
+  Array.cpp
+  Buffer.cpp
   BufferImage.cpp
-  Array.cpp
-  Image.cpp
-  Buffer.cpp
+  CategoriesManager.cpp
+  Category.cpp
   Debug.cpp
   ErrorMessage.cpp
   Function.cpp
+  Image.cpp
   Optimiser.cpp
   Parameter.cpp
   PixelDescription.cpp
@@ -24,13 +26,17 @@
   ScopedName.cpp
   String.cpp
   Type.cpp
-  TypeManager.cpp
+  TypesManager.cpp
   Value.cpp
+  Version.cpp
 # Internal files
+  wrappers/Allocate.cpp
   AST/AccessorExpression.cpp
   AST/BinaryExpression.cpp
   AST/ConvertExpression.cpp
   AST/CoumpoundExpression.cpp
+  AST/ConstantCoumpoundExpression.cpp
+  AST/GarbageCollectionStatement.cpp
   AST/Expression.cpp
   AST/FunctionDeclaration.cpp
   AST/Statement.cpp
@@ -46,15 +52,25 @@
   FloatHalfConverter_p.cpp
   GenerationContext_p.cpp
   LexerBase_p.cpp
+  MemoryManager_p.cpp
   ModuleData_p.cpp
   Optimiser_p.cpp
   ParserBase_p.cpp
   Token_p.cpp
   Type_p.cpp
-  TypeManager_p.cpp
+  TypesManager_p.cpp
   VariableNG_p.cpp
+  VariablesManager_p.cpp
   VirtualMachine_p.cpp
   Visitor_p.cpp
+# Metadata
+  Metadata/Debug_p.cpp
+  Metadata/Entry.cpp
+  Metadata/Group.cpp
+  Metadata/ParameterEntry.cpp
+  Metadata/TextEntry.cpp
+  Metadata/ValueEntry.cpp
+  Metadata/Factory_p.cpp
   ${LLVM_NATIVE_OBJECTS}
   )
 
@@ -69,9 +85,40 @@
 
 # __STDC_LIMIT_MACROS is needed by LLVM's DataTypes.h
 add_definitions( "-D__STDC_LIMIT_MACROS" )
+add_definitions( "-D__STDC_CONSTANT_MACROS" )
 add_definitions( -DCOUMPONENT_NAME="GTLCore" )
+if(OPENGTL_ENABLE_SIMD)
+add_definitions( -DENABLE_SIMD )
+endif(OPENGTL_ENABLE_SIMD)
 
 # installation
 install(TARGETS GTLCore  DESTINATION ${LIB_INSTALL_DIR} )
-install( FILES Parameter.h Function.h Array.h Buffer.h ErrorMessage.h PixelDescription.h Region.h RegionF.h ScopedName.h String.h Type.h Value.h Version.h Macros.h AbstractImage.h BufferImage.h Image.h DESTINATION ${INCLUDE_INSTALL_DIR}/GTLCore )
+install( FILES
+  AbstractImage.h
+  Array.h
+  Buffer.h
+  BufferImage.h
+  CategoriesManager.h
+  Category.h
+  ErrorMessage.h
+  Function.h
+  Macros.h
+  Image.h
+  Parameter.h
+  PixelDescription.h
+  Region.h
+  RegionF.h
+  ScopedName.h
+  String.h
+  Type.h
+  TypesManager.h
+  Value.h
+  Version.h
+  DESTINATION ${INCLUDE_INSTALL_DIR}/GTLCore )
 
+install( FILES Metadata/ParameterEntry.h Metadata/Entry.h Metadata/Group.h Metadata/TextEntry.h DESTINATION ${INCLUDE_INSTALL_DIR}/GTLCore/Metadata )
+
+# Create and install pc file
+configure_file("GTLCore.pc.cmake" "${CMAKE_CURRENT_BINARY_DIR}/GTLCore.pc" @ONLY)
+
+install(FILES ${CMAKE_CURRENT_BINARY_DIR}/GTLCore.pc DESTINATION ${LIB_INSTALL_DIR}/pkgconfig)

=== OpenGTL/GTLImageIO/CMakeLists.txt ===
--- 
+++ 
@@ -15,11 +15,22 @@
 
 # __STDC_LIMIT_MACROS is needed by LLVM's DataTypes.h
 add_definitions( "-D__STDC_LIMIT_MACROS" )
+add_definitions( "-D__STDC_CONSTANT_MACROS" )
 add_definitions( -DCOUMPONENT_NAME="GTLImageIO" )
+
+if(OPENGTL_BUILD_TESTS)
+add_definitions( -D_GTLIMAGEIO_EXTENSIONS_PNG_DIR_="${CMAKE_BINARY_DIR}/Extensions/PngDC" )
+add_definitions( -D_GTLIMAGEIO_EXTENSIONS_RAW_DIR_="${CMAKE_BINARY_DIR}/Extensions/RawDC" )
+endif(OPENGTL_BUILD_TESTS)
 
 # Set the ABI version of the library
 set_target_properties(GTLImageIO PROPERTIES VERSION ${OPENGTL_LIB_VERSION} SOVERSION ${OPENGTL_LIB_SOVERSION} )
 
 # Install target
 install(TARGETS GTLImageIO  DESTINATION ${LIB_INSTALL_DIR} )
-# install( FILES ImageDC.h DESTINATION ${INCLUDE_INSTALL_DIR}/GTLImageIO ) # NO REASON TO INSTALL HEADERS FOR NOW
+install( FILES ImageDC.h ImageDCRegistry.h DESTINATION ${INCLUDE_INSTALL_DIR}/GTLImageIO )
+
+# Create and install pc file
+configure_file("GTLImageIO.pc.cmake" "${CMAKE_CURRENT_BINARY_DIR}/GTLImageIO.pc" @ONLY)
+
+install(FILES ${CMAKE_CURRENT_BINARY_DIR}/GTLImageIO.pc DESTINATION ${LIB_INSTALL_DIR}/pkgconfig)

=== OpenGTL/tools/CMakeLists.txt ===
add_subdirectory(convert)
add_subdirectory(imagecompare)
add_subdirectory(mmbenchmark)

=== OpenShiva/OpenShiva/CMakeLists.txt ===

include_directories( ${LLVM_INCLUDE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/ ${CMAKE_CURRENT_SOURCE_DIR}/compiler ${CMAKE_CURRENT_BINARY_DIR} )

# List of files 
set(OpenShiva_SRCS
  Kernel.cpp
  Source.cpp
  SourcesCollection.cpp
  Version.cpp
# Internal files
  Compiler_p.cpp
  CodeGenerator_p.cpp
  Lexer_p.cpp
  LightParser_p.cpp
  Parser_p.cpp
  Wrapper_p.cpp
  PixelVisitor_p.cpp
  PixelConvertExpressionFactory_p.cpp
  Kernel_p.cpp
  Library.cpp
  LibrariesManager.cpp
# Metadata
  MetadataLexer_p.cpp
  MetadataParser_p.cpp
  Metadata.cpp
# Wrap
  wrappers/ImageWrap_p.cpp
  wrappers/PixelWrap_p.cpp
  wrappers/RegionWrap_p.cpp
    )

# Add the OpenSHIVA library for build
add_library(OpenShiva SHARED ${OpenShiva_SRCS})
target_link_libraries(OpenShiva GTLCore )

# __STDC_LIMIT_MACROS is needed by LLVM's DataTypes.h
add_definitions( "-D__STDC_LIMIT_MACROS" )
add_definitions( "-D__STDC_CONSTANT_MACROS" )
add_definitions( -DCOUMPONENT_NAME="OpenShiva" )

add_definitions( -D_OPENSHIVA_LIB_="${CMAKE_INSTALL_PREFIX}/lib/libOpenShiva.so.${OPENGTL_VERSION}")
add_definitions( -D_OPENSHIVA_SHIVA_STD_LIB_SRC_DIR_="${CMAKE_CURRENT_SOURCE_DIR}")
add_definitions( -D_OPENSHIVA_SHIVA_LIBRARIES_DIR_="${SHARE_INSTALL_DIR}/shiva/libraries" )
add_definitions( -D_OPENSHIVA_SHIVA_KERNELS_DIR_="${SHARE_INSTALL_DIR}/shiva/kernels" )


# Set the ABI version of the library
set_target_properties(OpenShiva PROPERTIES VERSION ${OPENSHIVA_LIB_VERSION} SOVERSION ${OPENSHIVA_LIB_SOVERSION} )

# Install target
install(TARGETS OpenShiva  DESTINATION ${LIB_INSTALL_DIR} )
install( FILES
  Kernel.h
  Library.h
  LibrariesManager.h
  Metadata.h
  Source.h
  SourcesCollection.h
  Version.h
  DESTINATION ${INCLUDE_INSTALL_DIR}/OpenShiva )

# Create and install pc file
configure_file("OpenShiva.pc.cmake" "${CMAKE_CURRENT_BINARY_DIR}/OpenShiva.pc" @ONLY)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/OpenShiva.pc DESTINATION ${LIB_INSTALL_DIR}/pkgconfig)  

# Install standard library
install(FILES shivastdlib.shiva DESTINATION ${SHARE_INSTALL_DIR}/shiva/libraries )

=== OpenShiva/tests/CMakeLists.txt ===
add_subdirectory( parse )
add_subdirectory( arithmetic )
add_subdirectory( library )
add_subdirectory( structures )
add_subdirectory( vectors )
add_subdirectory( imagegenerators )
add_subdirectory( convolution )
add_subdirectory( raw )

## opengtl 0.9.12

=== CMakeLists.txt ===
project(OpenGTL)

cmake_minimum_required(VERSION 2.6)

set(LIB_SUFFIX "" CACHE STRING "Define suffix of directory name (32/64)" )

option(OPENGTL_BUILD_TESTS "Build tests" OFF)
option(OPENGTL_ENABLE_DEBUG_OUTPUT "Enable (heavy) debug output (only do that for debugging OpenGTL" OFF)
option(OPENGTL_FULL_WARNINGS "Build OpenGTL with all warnings" OFF)

set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/modules )

set(OPENGTL_VERSION "0.9.12")
set(OPENGTL_LIB_VERSION ${OPENGTL_VERSION})
set(OPENGTL_LIB_SOVERSION "0.6")

set(LIB_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}/)
set(INCLUDE_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/include/)
set(BIN_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/bin/)
set(SHARE_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/share/OpenGTL/)
set(DOC_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/share/doc/OpenGTL/)
set(GTLIMAGEIO_EXTENSIONS_INSTALL_DIR ${LIB_INSTALL_DIR}/GTLImageIO/Extensions)

set(OPENGTL_TESTS_DATA "" CACHE FILEPATH "Directory that contains the data of the tests.")

include (TestBigEndian)
test_big_endian(CMAKE_WORDS_BIGENDIAN)
configure_file(config-endian.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-endian.h )

find_package(LLVM REQUIRED)
if( NOT LLVM_VERSION STREQUAL "2.6" )
  message(FATAL_ERROR "LLVM 2.6 is required.")
endif(NOT LLVM_VERSION STREQUAL "2.6" )

find_package(Threads)

if(CMAKE_USE_PTHREADS_INIT)
  set(PTHREAD_FOUND TRUE)
  set(GTLTEST_THREAD_SUPPORT TRUE)
  add_definitions(-DOPENGTL_HAVE_PTHREAD)
  add_definitions(-DGTLTEST_HAVE_THREAD)
  message(STATUS "pthread was found.")
else(CMAKE_USE_PTHREADS_INIT)
  message(STATUS "pthread wasn't found, thread tests won't be available and memory manager will use hash.")
endif(CMAKE_USE_PTHREADS_INIT)

if(OPENGTL_BUILD_TESTS)
  include(CTest)
  add_definitions(-DOPENGTL_ENABLE_TESTS)
endif(OPENGTL_BUILD_TESTS)

if(OPENGTL_ENABLE_DEBUG_OUTPUT)
  add_definitions(-DOPENGTL_ENABLE_DEBUG_OUTPUT)
endif(OPENGTL_ENABLE_DEBUG_OUTPUT)

if(OPENGTL_FULL_WARNINGS)
  set(OPENGTL_BUILD_DEFINITION "-Wall -Werror")
endif(OPENGTL_FULL_WARNINGS)

if(CMAKE_SIZEOF_VOID_P EQUAL 4)
  # 32 bits
  message(STATUS "OpenGTL detected that you use a 32 bit processor.")
  set(OPENGTL_TESTS_DATA_RESULTS_DIR results32)
  set(OPENGTL_32_BITS TRUE)
  
else(CMAKE_SIZEOF_VOID_P EQUAL 4)
  # 32 bits
  message(STATUS "OpenGTL detected that you use a 64 bit processor.")
  set(OPENGTL_TESTS_DATA_RESULTS_DIR results64)
  set(OPENGTL_32_BITS FALSE)
  # TODO check that llvm was build with -fPIC
  if(NOT LLVM_COMPILED_WITH_PIC)
    message(FATAL_ERROR "llvm wasn't build with PIC enabled, this is not surported on 64bits.")
  endif(NOT LLVM_COMPILED_WITH_PIC)
endif(CMAKE_SIZEOF_VOID_P EQUAL 4)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/OpenGTL ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_BINARY_DIR}/OpenGTL
)

# Test for visibility in gcc

if (CMAKE_COMPILER_IS_GNUCXX)
  include (MacroEnsureVersion)
  include (CheckCXXCompilerFlag)

  # visibility support
  check_cxx_compiler_flag(-fvisibility=hidden __GTL_HAVE_GCC_VISIBILITY)
  set( __GTL_HAVE_GCC_VISIBILITY ${__GTL_HAVE_GCC_VISIBILITY} CACHE BOOL "GCC support for hidden visibility")

   # get the gcc version
   exec_program(${CMAKE_C_COMPILER} ARGS ${CMAKE_C_COMPILER_ARG1} --version OUTPUT_VARIABLE _gcc_version_info)

   string (REGEX MATCH "[345]\\.[0-9]\\.[0-9]" _gcc_version "${_gcc_version_info}")
   # gcc on mac just reports: "gcc (GCC) 3.3 20030304 ..." without the patch level, handle this here:
   if (NOT _gcc_version)
      string (REGEX REPLACE ".*\\(GCC\\).* ([34]\\.[0-9]) .*" "\\1.0" _gcc_version "${_gcc_version_info}")
   endif (NOT _gcc_version)

   macro_ensure_version("4.1.0" "${_gcc_version}" GCC_IS_NEWER_THAN_4_1)
   macro_ensure_version("4.2.0" "${_gcc_version}" GCC_IS_NEWER_THAN_4_2)
   macro_ensure_version("4.3.0" "${_gcc_version}" GCC_IS_NEWER_THAN_4_3)

   # save a little by making local statics not threadsafe
   # ### do not enable it for older compilers, see
   # ### http://gcc.gnu.org/bugzilla/show_bug.cgi?id=31806
   if (GCC_IS_NEWER_THAN_4_3)
       set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-threadsafe-statics")
   endif (GCC_IS_NEWER_THAN_4_3)

   set(_GCC_COMPILED_WITH_BAD_ALLOCATOR FALSE)
   if (GCC_IS_NEWER_THAN_4_1)
      exec_program(${CMAKE_C_COMPILER} ARGS ${CMAKE_C_COMPILER_ARG1} -v OUTPUT_VARIABLE _gcc_alloc_info)
      string(REGEX MATCH "(--enable-libstdcxx-allocator=mt)" _GCC_COMPILED_WITH_BAD_ALLOCATOR "${_gcc_alloc_info}")
   endif (GCC_IS_NEWER_THAN_4_1)

   if (__GTL_HAVE_GCC_VISIBILITY AND GCC_IS_NEWER_THAN_4_1 AND NOT _GCC_COMPILED_WITH_BAD_ALLOCATOR AND NOT WIN32)
      set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden")

      if (GCC_IS_NEWER_THAN_4_2)
          set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility-inlines-hidden")
      endif (GCC_IS_NEWER_THAN_4_2)
   else (__GTL_HAVE_GCC_VISIBILITY AND GCC_IS_NEWER_THAN_4_1 AND NOT _GCC_COMPILED_WITH_BAD_ALLOCATOR AND NOT WIN32)
      set (__GTL_HAVE_GCC_VISIBILITY 0)
   endif (__GTL_HAVE_GCC_VISIBILITY AND GCC_IS_NEWER_THAN_4_1 AND NOT _GCC_COMPILED_WITH_BAD_ALLOCATOR AND NOT WIN32)

endif (CMAKE_COMPILER_IS_GNUCXX)

# Add subdirectories

add_subdirectory(OpenGTL)
add_subdirectory(OpenCTL)
add_subdirectory(OpenShiva)
add_subdirectory(Extensions)

=== OpenCTL/OpenCTL/CMakeLists.txt ===
--- 
+++ 
@@ -7,12 +7,18 @@
   Module.cpp
   ModulesManager.cpp
   Program.cpp
+  Template.cpp
   Version.cpp
 # Internal files
   StdLibFunctions.cpp
   compiler/Compiler.cpp
   compiler/LexerNG.cpp
   compiler/ParserNG.cpp
+# Template files
+  templatecompiler/GenerationContext_p.cpp
+  templatecompiler/TemplateAST.cpp
+  templatecompiler/TemplateLexer.cpp
+  templatecompiler/TemplateParser.cpp
   ${LLVM_NATIVE_OBJECTS}
     )
 
@@ -35,7 +41,14 @@
 
 # Install target
 install(TARGETS OpenCTL  DESTINATION ${LIB_INSTALL_DIR} )
-install( FILES Module.h ModulesManager.h Program.h Version.h DESTINATION ${INCLUDE_INSTALL_DIR}/OpenCTL )
+install( FILES
+  Export.h
+  Module.h
+  ModulesManager.h
+  Program.h
+  Template.h
+  Version.h
+  DESTINATION ${INCLUDE_INSTALL_DIR}/OpenCTL )
 
 # Create and install pc file
 configure_file("OpenCTL.pc.cmake" "${CMAKE_CURRENT_BINARY_DIR}/OpenCTL.pc" @ONLY)

=== OpenCTL/tools/CMakeLists.txt ===
add_subdirectory(compiler)
add_subdirectory(interpreter)
add_subdirectory(benchmark)
add_subdirectory(templatecompiler)

=== OpenGTL/GTLCore/CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,15 @@
-add_subdirectory(tests)
+if(OPENGTL_BUILD_TESTS)
+  add_subdirectory(tests)
+endif(OPENGTL_BUILD_TESTS)
 
 # Find llvm jit, interpreter and native
 FIND_LLVM_LIBS( ${LLVM_CONFIG_EXECUTABLE} "native bitwriter linker bitreader jit interpreter support ipo" LLVM_LIBS LLVM_NATIVE_OBJECTS )
 
 include_directories( ${LLVM_INCLUDE_DIR} )
+
+## Generate macros.h file
+
+configure_file(Macros.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/Macros.h )
 
 ## GTLCore library ##
 
@@ -21,6 +27,7 @@
   Optimiser.cpp
   Parameter.cpp
   PixelDescription.cpp
+  ProgressReport.cpp
   Region.cpp
   RegionF.cpp
   ScopedName.cpp
@@ -31,6 +38,7 @@
   Version.cpp
 # Internal files
   wrappers/Allocate.cpp
+  wrappers/ProgressReportWrap.cpp
   AST/AccessorExpression.cpp
   AST/BinaryExpression.cpp
   AST/ConvertExpression.cpp
@@ -46,6 +54,7 @@
   CompilerBase_p.cpp
   ConvertCenter_p.cpp
   ErrorMessages_p.cpp
+  ExpressionGenerationContext_p.cpp
   ExpressionResult_p.cpp
   Function_p.cpp
   FunctionCaller_p.cpp
@@ -87,9 +96,9 @@
 add_definitions( "-D__STDC_LIMIT_MACROS" )
 add_definitions( "-D__STDC_CONSTANT_MACROS" )
 add_definitions( -DCOUMPONENT_NAME="GTLCore" )
-if(OPENGTL_ENABLE_SIMD)
-add_definitions( -DENABLE_SIMD )
-endif(OPENGTL_ENABLE_SIMD)
+if(OPENGTL_32_BITS)
+add_definitions( -DOPENGTL_32_BITS )
+endif(OPENGTL_32_BITS)
 
 # installation
 install(TARGETS GTLCore  DESTINATION ${LIB_INSTALL_DIR} )
@@ -101,11 +110,13 @@
   CategoriesManager.h
   Category.h
   ErrorMessage.h
+  Export.h
   Function.h
-  Macros.h
+  ${CMAKE_CURRENT_BINARY_DIR}/Macros.h
   Image.h
   Parameter.h
   PixelDescription.h
+  ProgressReport.h
   Region.h
   RegionF.h
   ScopedName.h

=== OpenGTL/GTLImageIO/CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,8 @@
 
 set(GTLImageIO_SRCS
     ImageDC.cpp
-    ImageDCRegistry.cpp )
+    ImageDCRegistry.cpp
+    Version.cpp )
 
 add_definitions( -D_GTLIMAGEIO_EXTENSIONS_INSTALL_DIR_="${GTLIMAGEIO_EXTENSIONS_INSTALL_DIR}" )
 
@@ -28,7 +29,11 @@
 
 # Install target
 install(TARGETS GTLImageIO  DESTINATION ${LIB_INSTALL_DIR} )
-install( FILES ImageDC.h ImageDCRegistry.h DESTINATION ${INCLUDE_INSTALL_DIR}/GTLImageIO )
+install( FILES
+  Export.h
+  ImageDC.h
+  ImageDCRegistry.h
+  DESTINATION ${INCLUDE_INSTALL_DIR}/GTLImageIO )
 
 # Create and install pc file
 configure_file("GTLImageIO.pc.cmake" "${CMAKE_CURRENT_BINARY_DIR}/GTLImageIO.pc" @ONLY)

=== OpenShiva/OpenShiva/CMakeLists.txt ===
--- 
+++ 
@@ -18,6 +18,7 @@
   PixelConvertExpressionFactory_p.cpp
   Kernel_p.cpp
   Library.cpp
+  LibraryCompilation_p.cpp
   LibrariesManager.cpp
 # Metadata
   MetadataLexer_p.cpp
@@ -27,6 +28,7 @@
   wrappers/ImageWrap_p.cpp
   wrappers/PixelWrap_p.cpp
   wrappers/RegionWrap_p.cpp
+  wrappers/rand.cpp
     )
 
 # Add the OpenSHIVA library for build
@@ -50,6 +52,7 @@
 # Install target
 install(TARGETS OpenShiva  DESTINATION ${LIB_INSTALL_DIR} )
 install( FILES
+  Export.h
   Kernel.h
   Library.h
   LibrariesManager.h

=== OpenShiva/tools/CMakeLists.txt ===
add_subdirectory(compiler)
add_subdirectory(interpreter)
add_subdirectory(tester)

add_subdirectory(shivainfo)

=== OpenCTL/tools/interpreter/CMakeLists.txt ===
include_directories( ${CMAKE_SOURCE_DIR} )

set(ctlexec_SRCS
  CtlI.cpp
    )

add_definitions( -DCOUMPONENT_NAME=\"\\\"CTLi\\\"\" )
add_executable(ctli ${ctlexec_SRCS})
target_link_libraries(ctli OpenCTL )
install( TARGETS ctli DESTINATION ${BIN_INSTALL_DIR} )

=== OpenCTL/tools/templatecompiler/CMakeLists.txt ===
include_directories( ${CMAKE_SOURCE_DIR} )

set(ctltc_SRCS
  CtlTC.cpp
    )

add_executable(ctltc ${ctltc_SRCS})
target_link_libraries(ctltc OpenCTL )
install( TARGETS ctltc DESTINATION ${BIN_INSTALL_DIR} )

=== OpenGTL/GTLCore/tests/CMakeLists.txt ===
include_directories( ${GTL_Core_DIR} )

set(TestGTLCore_SRCS
  TestGTLCore.cpp
    )

add_executable(TestGTLCore ${TestGTLCore_SRCS})
target_link_libraries(TestGTLCore GTLCore GTLTest )
add_test(TestGTLCore TestGTLCore)

=== OpenGTL/tools/imagecompare/CMakeLists.txt ===
include_directories( ${CMAKE_SOURCE_DIR} )

set( ImageCompare_SRCS
     ImageCompare.cpp )

add_definitions( -DCOUMPONENT_NAME=\"\\\"ImageCompare\\\"\" )

add_executable(imagecompare ${ImageCompare_SRCS})
target_link_libraries(imagecompare GTLImageIO )
install( TARGETS imagecompare DESTINATION ${BIN_INSTALL_DIR} )

=== OpenShiva/tests/parse/CMakeLists.txt ===

set( TESTS_FILES
  metadata.shiva
  kernel.shiva
  for.shiva
  region.shiva
  import.shiva
  multipledependent.shiva
  dependentarray.shiva
  cstyleconvertinexpressions.shiva
  hints.shiva
  )

FOREACH( TEST_FILE ${TESTS_FILES} )
  ADD_TEST(${TEST_FILE} ${SHIVAC} -L ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/${TEST_FILE})
ENDFOREACH( TEST_FILE )

set( TESTS_FAIL_FILES
  samefunctionsignature.shiva
  dependentpixel.shiva
  constpixel.shiva
  metadatargb.shiva
  )

FOREACH( TEST_FILE ${TESTS_FAIL_FILES} )
  ADD_TEST(${TEST_FILE} ${CMAKE_CURRENT_SOURCE_DIR}/../../../sdk/invertresult.sh ${SHIVAC} ${CMAKE_CURRENT_SOURCE_DIR}/${TEST_FILE})
ENDFOREACH( TEST_FILE )

=== debian/changelog ===
opengtl (0.9.12-0ubuntu2) lucid; urgency=low

  * debian/libgtlcore0.install:
    - Add missing file usr/share/OpenGTL/shiva/shivastdlib.shiva
  * debian/libgtlcore-dev.install:
    - Add missing file GTLCore.pc
    - Add missing file GTLImageIO.pc
    - Add missing includes directory GTLImageIO
  * debian/opengtl-tools.install:
    - Add missing files gtlconvert, imagecompre, and shivainfo

 -- Richard A. Johnson <nixternal@ubuntu.com>  Wed, 13 Jan 2010 00:14:35 -0600

opengtl (0.9.12-0ubuntu1) lucid; urgency=low

  * New upstream release:
    - Bump build-depend version of llvm-dev to 2.6
  * Use Debian source format 3.0 (quilt)
  * Remove kubuntu_01_disable_llvm_vercheck.diff, no longer needed
  * Remove quilt build-dependency
  * Switch to debhelper short-style rules:
    - Bump debian/compat to 7
    - Bump debhelper build-depend version to 7
    - Remove cdbs build-dependency
    - Use debhelper short rules in debian/rules
  * Solve weak-library-dev-dependency issues for the -dev packages
  * Bump Standards-Version to 3.8.3
  * Whitespace fix in debian/changelog

 -- Jonathan Thomas <echidnaman@kubuntu.org>  Sat, 09 Jan 2010 16:07:34 -0500

opengtl (0.9.9-0ubuntu1) karmic; urgency=low

  * New upstream release:
    - Add kubuntu_01_disable_llvm_vercheck.diff since we have an svn version
      of llvm that's higher than 2.5 (opengtl wants exactly 2.5 since they
      also made a 2.4 release)
    - Bump llvm build-dep version to (>= 2.5)
    - Update .install files
  * Bump Standards-Version to 3.8.1

 -- Jonathan Thomas <echidnaman@kubuntu.org>  Thu, 28 May 2009 22:31:29 -0400

opengtl (0.9.5-0ubuntu3) jaunty; urgency=low

  * Ensure -dev packages depend on their libraries
  * Build against llvm fixed for amd64

 -- Jonathan Riddell <jriddell@ubuntu.com>  Fri, 14 Nov 2008 21:10:37 +0000

opengtl (0.9.5-0ubuntu2) jaunty; urgency=low

  * Build-dep on llvm-dev

 -- Jonathan Riddell <jriddell@ubuntu.com>  Fri, 14 Nov 2008 01:05:30 +0000

opengtl (0.9.5-0ubuntu1) jaunty; urgency=low

  * Initial release

 -- Jonathan Riddell <jriddell@ubuntu.com>  Thu, 13 Nov 2008 11:57:40 +0000

=== debian/control ===
Source: opengtl
Section: graphics
Priority: extra
Maintainer: Ubuntu MOTU Developers <ubuntu-motu@lists.ubuntu.com>
XSBC-Original-Maintainer: Jonathan Riddell <jriddell@ubuntu.com>
Build-Depends: debhelper (>= 7), cmake, llvm-dev (>= 2.6)
Standards-Version: 3.8.3
Homepage: http://www.opengtl.org/

Package: libgtlcore0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Graphics Transformation Libraries
 OpenGTL, Graphics (or Generics) Transformation Libraries (Languages).
 .
 Tools, languages and libraries to create generic transformation for
 graphics. Those transformations could then be used by different
 programs
 .
 This package contains the libgtlcore and libshiva libraries.

Package: libopenctl0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: OpenCTL from Graphics Transformation Libraries
 OpenGTL, Graphics (or Generics) Transformation Libraries (Languages).
 .
 Tools, languages and libraries to create generic transformation for
 graphics. Those transformations could then be used by different
 programs
 .
 This package contains the OpenCTL (Colour Transformation Language)
 library.

Package: libgtlcore-dev
Section: libdevel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libgtlcore0 (= ${binary:Version})
Description: Graphics Transformation Libraries
 OpenGTL, Graphics (or Generics) Transformation Libraries (Languages).
 .
 Tools, languages and libraries to create generic transformation for
 graphics. Those transformations could then be used by different
 programs
 .
 This package contains development files for libgtlcore and libshiva.

Package: libopenctl-dev
Section: libdevel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libgtlcore-dev, libopenctl0 (= ${binary:Version})
Description: Graphics Transformation Libraries
 OpenGTL, Graphics (or Generics) Transformation Libraries (Languages).
 .
 Tools, languages and libraries to create generic transformation for
 graphics. Those transformations could then be used by different
 programs
 .
 This package contains development files for OpenCTL.

Package: opengtl-tools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Graphics Transformation Libraries
 OpenGTL, Graphics (or Generics) Transformation Libraries (Languages).
 .
 Tools, languages and libraries to create generic transformation for
 graphics. Those transformations could then be used by different
 programs
 .
 This package contains some tools that are useful when developing for
 OpenGTL, or to use some of its functionality from the command line:
  - ctlc compile a ctl program
  - ctli execute a function from a ctl program
  - shivac compile a shiva kernel
  - shiva apply a kernel on a set of images
